/* Copyright 1996, Jan D. Wolter and Steven R. Weiss, All Rights Reserved. */

#include "backtalk.h"

#include "udb.h"
#include "authident.h"
#include "initcmd.h"

#ifdef DMALLOC
#include "dmalloc.h"
#endif

#ifdef ID_GETUID
int direct_exec= FALSE;
#endif


main(int argc, char **argv)
{
    char bf[BFSZ];
    struct btpasswd *pw;
    int force=0, i;

#if NOPWEDIT
    fprintf(stderr,"%s not supported at this site.\n",argv[0]);
    exit(1);
#else
    init_cmd(argv[0]);

    if (argc > 1 && !strcmp(argv[1],"-f"))
	force= 1;

    if (argc <= 1+force)
    {
	fprintf(stderr,"usage: %s [-f] <username>...\n",argv[0]);
	exit(1);
    }

    for (i= 1+force; i < argc; i++)
    {
	if ((pw= getdbnam(argv[i])) == NULL)
	{
	    fprintf(stderr,"Backtalk account %s does not exist.\n", argv[i]);
	    continue;
	}
	if (!force)
	{
	    fprintf(stderr,"Delete %s Backtalk account? ", argv[i]);
	    fgets(bf,BFSZ,stdin);
	    if (bf[0] != 'y' && bf[0] != 'Y')
		continue;
	}

	if (kill_user(pw))
	    fprintf(stderr,"could not kill %s.\n",argv[i]);
	else
	    fprintf(stderr,"%s deleted.\n",argv[i]);
    }
    exit(0);
#endif
}

char *get_noise() {return NULL;}        /* dummy */
